<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJobResultInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfJobResultInsert extends AbstractStructArrayBase
{
    /**
     * The JobResultInsert
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\JobResultInsert[]
     */
    public $JobResultInsert;
    /**
     * Constructor method for ArrayOfJobResultInsert
     * @uses ArrayOfJobResultInsert::setJobResultInsert()
     * @param \StructType\JobResultInsert[] $jobResultInsert
     */
    public function __construct(array $jobResultInsert = array())
    {
        $this
            ->setJobResultInsert($jobResultInsert);
    }
    /**
     * Get JobResultInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\JobResultInsert[]|null
     */
    public function getJobResultInsert()
    {
        return isset($this->JobResultInsert) ? $this->JobResultInsert : null;
    }
    /**
     * This method is responsible for validating the values passed to the setJobResultInsert method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJobResultInsert method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJobResultInsertForArrayConstraintsFromSetJobResultInsert(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJobResultInsertJobResultInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfJobResultInsertJobResultInsertItem instanceof \StructType\JobResultInsert) {
                $invalidValues[] = is_object($arrayOfJobResultInsertJobResultInsertItem) ? get_class($arrayOfJobResultInsertJobResultInsertItem) : sprintf('%s(%s)', gettype($arrayOfJobResultInsertJobResultInsertItem), var_export($arrayOfJobResultInsertJobResultInsertItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The JobResultInsert property can only contain items of type \StructType\JobResultInsert, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set JobResultInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\JobResultInsert[] $jobResultInsert
     * @return \ArrayType\ArrayOfJobResultInsert
     */
    public function setJobResultInsert(array $jobResultInsert = array())
    {
        // validation for constraint: array
        if ('' !== ($jobResultInsertArrayErrorMessage = self::validateJobResultInsertForArrayConstraintsFromSetJobResultInsert($jobResultInsert))) {
            throw new \InvalidArgumentException($jobResultInsertArrayErrorMessage, __LINE__);
        }
        if (is_null($jobResultInsert) || (is_array($jobResultInsert) && empty($jobResultInsert))) {
            unset($this->JobResultInsert);
        } else {
            $this->JobResultInsert = $jobResultInsert;
        }
        return $this;
    }
    /**
     * Add item to JobResultInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\JobResultInsert $item
     * @return \ArrayType\ArrayOfJobResultInsert
     */
    public function addToJobResultInsert(\StructType\JobResultInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JobResultInsert) {
            throw new \InvalidArgumentException(sprintf('The JobResultInsert property can only contain items of type \StructType\JobResultInsert, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->JobResultInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JobResultInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JobResultInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JobResultInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JobResultInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JobResultInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string JobResultInsert
     */
    public function getAttributeName()
    {
        return 'JobResultInsert';
    }
}
